
\section{Experimental Things}
\label{sec:experimental}

\subsection{swr.benchmark Module}

In order to validate some concrete communication modules made on top of \emph{Somewhere2} abstract communication api, it was implemented
a test-only module called \emph{benchmark} module. This module aims to simulate propagation over a network of peers in order to evaluate
the performance of sending/receiving message process.

As the \emph{distributed reasoning} module, this module contains three main special types of message: the \emph{Query} message which 
triggers the simulation of a local calculus on a peer, the \emph{Answer} message which can be sent as the results a local calculus or 
can be created by the combination of different answers from neighbour peers, and finally, the \emph{Finish} message which represents 
the end a reasoning of a propagation. For each \emph{Query} message sent from a peer, a \emph{Finish} message must be received and 
so then, a \emph{Finish} message can be sent from the local peer to the user or to another peer who started the propagation. 
If the number of finishes do not corresponds to the number of queries sent by the peer, the calculus will be ended by a \emph{timeout} 
routine.

In order to use this module, \emph{Somewhere2} must be compiled using one of these profiles: \emph{benchmark-jgroups}, \emph{benchmark-jxta} and
\emph{benchmark-shoal}. Using these different compilations one can evaluate different aspects of performance between, for example,
different P2P frameworks.